Index: src/main/java/com/tourMate/services/UsersManager.java
===================================================================
--- src/main/java/com/tourMate/services/UsersManager.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/services/UsersManager.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -1,4 +1,5 @@
 package com.tourMate.services;
 
+import com.tourMate.dto.PrincipalInfo;
 import com.tourMate.entities.User;
 
@@ -20,3 +21,10 @@
 
     void unlock(Long id);
+
+    List<User> getAdmins();
+
+    void connectAccount(Long id, String username, String password);
+
+    List<User> findConnectedAccountsByUser(Long id);
+    PrincipalInfo getPrincipalInfo(Long userId);
 }
Index: src/main/java/com/tourMate/services/impl/HotelManagerImpl.java
===================================================================
--- src/main/java/com/tourMate/services/impl/HotelManagerImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/services/impl/HotelManagerImpl.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -13,7 +13,5 @@
 
 import java.time.Duration;
-import java.util.Date;
-import java.util.List;
-import java.util.Map;
+import java.util.*;
 import java.util.stream.Collectors;
 
@@ -123,5 +121,6 @@
 
     @Override
-    public void createRoom(Hotels hotel, String hotelRoomDescription, String hotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price, int numOfBeds) {
+    public void createRoom(Long hotelId, String hotelRoomDescription, String hotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price, int numOfBeds) {
+        Hotels hotel = findHotelByID(hotelId);
         HotelRoom hotelRoom = new HotelRoom(hotel, hotelRoomDescription, hotelRoomName, kitchenAvailable, airConditioning, balcony, price, numOfBeds);
         hotelDao.createRoom(hotelRoom);
@@ -154,5 +153,6 @@
 
     @Override
-    public void createRoomAvailible(HotelRoom hotelRoom, Date dateFrom, Date dateTo, int numberOfBeds) {
+    public void createRoomAvailible(long hotelRoomId, Date dateFrom, Date dateTo, int numberOfBeds) {
+        HotelRoom hotelRoom = findRoomById(hotelRoomId);
         HotelRoomAvailable hra = new HotelRoomAvailable(hotelRoom, dateFrom, dateTo, numberOfBeds);
         hotelDao.createRoomAvailible(hra);
@@ -168,5 +168,9 @@
         hotelDao.editRoomAvailible(hr);
     }
-
+    //01-01-2024 - 30-01-2024
+    //05-01-2024 - 10-01-2024
+
+    //01-01 - 05-01
+    //10-01 - 30-01
     @Override
     public void editRoomAvailibleReservation(Long HotelRoomAvailableId, Long hotelRoomId, Date from, Date to, int numberOfBeds){
@@ -202,6 +206,31 @@
 
     @Override
+    public List<HotelRoomReservations> getReservationsInPeriod(String hotelLocation, Date dateFrom, Date dateTo)
+    {
+        return hotelDao.getReservationsInPeriod(hotelLocation, dateFrom, dateTo);
+    }
+
+    @Override
     public List<HotelDto> getRoomsAvailibilityByDateAndLocation(String hotelLocation, Date dateFrom, Date dateTo, int numberOfBeds, Boolean flexible) {
         long numberOfNights = Duration.between(dateFrom.toInstant(), dateTo.toInstant()).toDays();
+        List<Hotels> hotels = getHotelsByLocation(hotelLocation);
+        List<HotelRoomReservations> hotelRoomReservations = getReservationsInPeriod(hotelLocation, dateFrom, dateTo);
+        List<Hotels> hotelsWithReservations = hotelRoomReservations.stream().map(x -> x.getHotelRoom().getHotel()).toList();
+        List<Hotels> mostReservedHotels = hotelRoomReservations.stream()
+                .collect(Collectors.groupingBy(x -> x.getHotelRoom().getHotel(), Collectors.counting())).entrySet().stream()
+                .sorted(Map.Entry.comparingByValue(Comparator.reverseOrder()))
+                .limit(5)
+                .map(Map.Entry::getKey)
+                .toList();
+        List<Hotels> leastReservedHotels = hotelRoomReservations.stream()
+                .collect(Collectors.groupingBy(x -> x.getHotelRoom().getHotel(), Collectors.counting())).entrySet().stream()
+                .sorted(Map.Entry.comparingByValue())
+                .limit(5)
+                .map(Map.Entry::getKey)
+                .toList();
+        List<Hotels> hotelsWithoutReservations = hotels.stream().filter(x -> !hotelsWithReservations.contains(x)).toList();
+        List<Hotels> hotelsToBeMarketed = new ArrayList<>();
+        hotelsToBeMarketed.addAll(hotelsWithoutReservations);
+        hotelsToBeMarketed.addAll(leastReservedHotels);
         List<HotelRoomAvailable> roomsAvailible = hotelDao.getRoomsAvailibilityByDateAndLocation(hotelLocation, dateFrom, dateTo, numberOfBeds, flexible);
         Map<Hotels, List<HotelRoomAvailable>> roomsByHotels = roomsAvailible.stream().collect(Collectors.groupingBy(x -> x.getHotelRoom().getHotel()));
@@ -220,5 +249,7 @@
                         getReviewsForHotel(x.getHotelId()),
                         getReviewsForHotel(x.getHotelId()).stream().mapToDouble(Reviews::getNumStar).average().orElse(0),
-                        getHotelImages(x.getHotelId())
+                        getHotelImages(x.getHotelId()),
+                        mostReservedHotels.contains(x),
+                        hotelsToBeMarketed.contains(x)
                 )).toList();
         return hotelsList;
@@ -227,4 +258,5 @@
 
     @Override
+    // TODO:Transactional
     public void createReservation(Long userId, Long hotelRoomId, Long hotelRoomAvailableId, Date dateFrom, Date dateTo, Integer numberOfBeds) {
         HotelRoom room = hotelDao.findRoomById(hotelRoomId);
@@ -246,4 +278,5 @@
         hotelDao.editReservation(hr);
     }
+
 
     @Override
Index: src/main/java/com/tourMate/services/impl/MailingServiceImpl.java
===================================================================
--- src/main/java/com/tourMate/services/impl/MailingServiceImpl.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/services/impl/MailingServiceImpl.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,26 @@
+package com.tourMate.services.impl;
+
+import com.tourMate.services.MailingService;
+import org.springframework.mail.SimpleMailMessage;
+import org.springframework.mail.javamail.JavaMailSender;
+import org.springframework.stereotype.Service;
+
+@Service
+public class MailingServiceImpl implements MailingService {
+
+    private final JavaMailSender emailSender;
+
+    public MailingServiceImpl(JavaMailSender emailSender) {
+        this.emailSender = emailSender;
+    }
+
+    @Override
+    public void sendMail(String to, String subject, String messageText) {
+        SimpleMailMessage mail = new SimpleMailMessage();
+        mail.setFrom("Trip2MK");
+        mail.setTo(to);
+        mail.setSubject(subject);
+        mail.setText(messageText);
+        emailSender.send(mail);
+    }
+}
Index: src/main/java/com/tourMate/services/impl/RestaurantManagerImpl.java
===================================================================
--- src/main/java/com/tourMate/services/impl/RestaurantManagerImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/services/impl/RestaurantManagerImpl.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -89,6 +89,14 @@
 
     @Override
-    public List<RestaurantDto> getTablesByDateAndLocation(String restaurantLocation, Date hourFrom, Date hourTo, int noSeats) {
-        List<RestaurantsAvailible> restaurantsAvailibles = restaurantDao.getTablesByDateAndLocation(restaurantLocation, hourFrom, hourTo, noSeats);
+    public List<RestaurantDto> getTablesByDateAndLocation(String restaurantLocation, Date date, String hourFrom, String hourTo, int noSeats) {
+        Date dateFrom = date;
+        Date dateTo = Date.from(date.toInstant());
+        String[] splittedFrom = hourFrom.split(":");
+        String[] splittedTo = hourTo.split(":");
+        dateFrom.setHours(Integer.parseInt(splittedFrom[0]));
+        dateFrom.setMinutes(Integer.parseInt(splittedFrom[1]));
+        dateTo.setHours(Integer.parseInt(splittedTo[0]));
+        dateTo.setMinutes(Integer.parseInt(splittedTo[1]));
+        List<RestaurantsAvailible> restaurantsAvailibles = restaurantDao.getTablesByDateAndLocation(restaurantLocation, dateFrom, dateTo, noSeats);
         Map<Restaurant, List<RestaurantsAvailible>> tablesByRestaurants = restaurantsAvailibles.stream().collect(Collectors.groupingBy(x -> x.getRestaurantTable().getRestaurant()));
         List<RestaurantDto> restaurantsList = tablesByRestaurants.keySet().stream()
Index: src/main/java/com/tourMate/services/impl/TransportManagerImpl.java
===================================================================
--- src/main/java/com/tourMate/services/impl/TransportManagerImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/services/impl/TransportManagerImpl.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -46,5 +46,33 @@
     public List<TransportDto> getTransportsByUser(long userId) {
         User u = usersManager.findUserByID(userId);
-        return transportDao.getTransportsByUser(u);
+        List<Transport> transports = transportDao.getTransportsByUser(u);
+        return transports.stream().map(x -> new TransportDto(
+                x.getTransportID(),
+                x.getTransportName(),
+                x.getCarBrand(),
+                x.getCarType(),
+                x.getCarManufacturedYear(),
+                x.getNoPassengers(),
+                x.getNoBags(),
+                x.getEMBG(),
+                x.getOwner(),
+                x.getCarPlate(),
+                x.getAvailableRoutes().stream().map(y -> new RouteListingDto(
+                        y.getTransportAvailibleId(),
+                        y.getFrom(),
+                        y.getTo(),
+                        y.getDate(),
+                        y.getFreeSpace(),
+                        y.getTime(),
+                        y.getRoutes(),
+                        y.getRoutes().stream()
+                                .mapToDouble(TransportRoute::getPrice)
+                                .max().orElse(0)
+                )).toList(),
+                x.getAvailableRoutes().stream()
+                        .flatMapToDouble(y -> y.getRoutes()
+                                .stream()
+                                .mapToDouble(TransportRoute::getPrice)).max().orElseGet(() -> 0)
+        )).toList();
     }
 
@@ -52,10 +80,49 @@
     public List<RouteListingDto> getRoutesForTransport(long transportId) {
         Transport t = getTransportById(transportId);
-        return transportDao.getRoutesForTransport(t);
+        List<TransportAvailible> transportAvailibles = transportDao.getRoutesForTransport(t);
+        return transportAvailibles.stream().map(x -> new RouteListingDto(
+                x.getTransportAvailibleId(),
+                x.getFrom(),
+                x.getTo(),
+                x.getDate(),
+                x.getFreeSpace(),
+                x.getTime(),
+                x.getRoutes(),
+                x.getRoutes().stream()
+                        .mapToDouble(TransportRoute::getPrice)
+                        .max().orElse(0)
+        )).toList();
     }
 
     @Override
     public TransportDto findTransportById(long transportId) {
-        return transportDao.findTransportById(transportId);
+        Transport x = transportDao.findTransportById(transportId);
+        return new TransportDto(
+                x.getTransportID(),
+                x.getTransportName(),
+                x.getCarBrand(),
+                x.getCarType(),
+                x.getCarManufacturedYear(),
+                x.getNoPassengers(),
+                x.getNoBags(),
+                x.getEMBG(),
+                x.getOwner(),
+                x.getCarPlate(),
+                x.getAvailableRoutes().stream().map(y -> new RouteListingDto(
+                        y.getTransportAvailibleId(),
+                        y.getFrom(),
+                        y.getTo(),
+                        y.getDate(),
+                        y.getFreeSpace(),
+                        y.getTime(),
+                        y.getRoutes(),
+                        y.getRoutes().stream()
+                                .mapToDouble(TransportRoute::getPrice)
+                                .max().orElse(0)
+                )).toList(),
+                x.getAvailableRoutes().stream()
+                        .flatMapToDouble(y -> y.getRoutes()
+                                .stream()
+                                .mapToDouble(TransportRoute::getPrice)).max().orElseGet(() -> 0));
     }
 
@@ -152,6 +219,12 @@
 
     @Override
-    public void createTransportAvailable(Transport transport, String departureLocation, String arrivalLocation, Date date, Integer noSeats, Date departureHour, Collection<TransportRoute> routes) {
-        TransportAvailible ta=new TransportAvailible(transport,departureLocation,arrivalLocation,date,noSeats,departureHour);
+    public void createTransportAvailable(TransportAvailible transportAvailible, Transport transport, String departureLocation, String arrivalLocation, Date date, Integer noSeats, Date departureHour, Long transportId, Collection<TransportRoute> trRoutes) {
+        Transport t = getTransportById(transportId);
+        List<TransportRoute> routes = trRoutes.stream().toList();
+        routes.get(0).setDeparture(transportAvailible.getDate());
+        transportAvailible.setTime(routes.get(routes.size() - 1).getArrival());
+        routes.forEach(x -> x.setParentRoute(transportAvailible));
+        transportAvailible.setTransport(t);
+        TransportAvailible ta=new TransportAvailible(t,departureLocation,arrivalLocation,date,noSeats,departureHour);
         transportDao.createTransportAvailable(ta);
         routes.forEach(x -> {
Index: src/main/java/com/tourMate/services/impl/UsersManagerImpl.java
===================================================================
--- src/main/java/com/tourMate/services/impl/UsersManagerImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/services/impl/UsersManagerImpl.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -2,10 +2,14 @@
 
 import com.tourMate.dao.UsersDao;
+import com.tourMate.dto.PrincipalInfo;
 import com.tourMate.entities.User;
+import com.tourMate.events.OnProfileEnabledEvent;
 import com.tourMate.services.UsersManager;
 import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.context.ApplicationEventPublisher;
 import org.springframework.security.core.userdetails.UserDetails;
 import org.springframework.security.core.userdetails.UserDetailsService;
 import org.springframework.security.core.userdetails.UsernameNotFoundException;
+import org.springframework.security.crypto.password.PasswordEncoder;
 import org.springframework.stereotype.Service;
 
@@ -18,5 +22,8 @@
     @Autowired
     UsersDao usersDao;
-
+    @Autowired
+    ApplicationEventPublisher eventPublisher;
+    @Autowired
+    PasswordEncoder passwordEncoder;
     @Override
     public void createUser(String name, String surname, String email, Date birthDate, String address, String contact) {
@@ -64,4 +71,39 @@
 
     @Override
+    public List<User> getAdmins() {
+        return usersDao.getAdmins();
+    }
+
+    @Override
+    public void connectAccount(Long id, String username, String password) {
+        User u1 = findUserByID(id);
+        User u2 = (User) loadUserByUsername(username);
+        if(passwordEncoder.matches(password, u2.getPassword()))
+        {
+            u1.addConnectedUser(u2);
+        }
+        usersDao.updateUser(u1);
+    }
+
+    @Override
+    public List<User> findConnectedAccountsByUser(Long id) {
+        User u = findUserByID(id);
+        return usersDao.findConnectedAccountsByUser(u);
+    }
+
+    @Override
+    public PrincipalInfo getPrincipalInfo(Long userId) {
+        PrincipalInfo principalInfo = new PrincipalInfo();
+        User u = findUserByID(userId);
+        principalInfo.setUsername(u.getUsername());
+        principalInfo.setRole(u.getRole().getRoleName());
+        principalInfo.setId(userId);
+        principalInfo.setName(u.getName());
+        principalInfo.setEmail(u.getEmail());
+        principalInfo.setSurname(u.getSurname());
+        return principalInfo;
+    }
+
+    @Override
     public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
         return usersDao.findUserByUsername(username);
